diff --git a/src/backend/catalog/namespace.c b/src/backend/catalog/namespace.c
index 5dbac9c437..145431d3ea 100644
--- a/src/backend/catalog/namespace.c
+++ b/src/backend/catalog/namespace.c
@@ -29,6 +29,7 @@
 #include "catalog/pg_collation.h"
 #include "catalog/pg_conversion.h"
 #include "catalog/pg_namespace.h"
+#include "catalog/pg_module.h"
 #include "catalog/pg_opclass.h"
 #include "catalog/pg_operator.h"
 #include "catalog/pg_opfamily.h"
@@ -208,7 +209,8 @@ static void NamespaceCallback(Datum arg, int cacheid, uint32 hashvalue);
 static bool MatchNamedCall(HeapTuple proctup, int nargs, List *argnames,
 						   bool include_out_arguments, int pronargs,
 						   int **argnumbers);
-
+static Oid qualifiedNameGetCreationNamespaceHelper(List *names, Oid *moduleId,
+												   char **objname_p, bool check_module);
 
 /*
  * RangeVarGetRelidExtended
@@ -954,23 +956,34 @@ FuncnameGetCandidates(List *names, int nargs, List *argnames,
 	FuncCandidateList resultList = NULL;
 	bool		any_special = false;
 	char	   *schemaname;
+	char       *modulename;
 	char	   *funcname;
-	Oid			namespaceId;
+	Oid	        namespaceId;
+	Oid         moduleId = InvalidOid;
 	CatCList   *catlist;
 	int			i;
+	bool        discardSchemanameIfNoMatch = false;
 
 	/* check for caller error */
 	Assert(nargs >= 0 || !(expand_variadic | expand_defaults));
 
 	/* deconstruct the name list */
-	DeconstructQualifiedName(names, &schemaname, &funcname);
+	DeconstructQualifiedNameWithModule(names, &schemaname, &modulename, &funcname);
 
 	if (schemaname)
 	{
-		/* use exact schema given */
-		namespaceId = LookupExplicitNamespace(schemaname, missing_ok);
-		if (!OidIsValid(namespaceId))
-			return NULL;
+		/* use exact schema given, missing_ok because if there is no schema,
+		   we will still check for a module by that name */
+
+		namespaceId = LookupExplicitNamespace(schemaname, true /* missing_ok */);
+
+		/* if no schema with that name is found, then treat it as a module name */
+		if (!OidIsValid(namespaceId) || namespaceId == 0) {
+			modulename = schemaname;
+			/* we need namespace search to find schema */
+			namespaceId = InvalidOid;
+			recomputeNamespacePath();
+		}
 	}
 	else
 	{
@@ -979,7 +992,8 @@ FuncnameGetCandidates(List *names, int nargs, List *argnames,
 		recomputeNamespacePath();
 	}
 
-	/* Search syscache by name only */
+	/* Search syscache by name only. Check every result to see if it is in search path and
+	   if it matches with module name, if any */
 	catlist = SearchSysCacheList1(PROCNAMEARGSNSP, CStringGetDatum(funcname));
 
 	for (i = 0; i < catlist->n_members; i++)
@@ -994,33 +1008,70 @@ FuncnameGetCandidates(List *names, int nargs, List *argnames,
 		bool		use_defaults;
 		Oid			va_elem_type;
 		int		   *argnumbers = NULL;
+		Oid        schemaOid;
 		FuncCandidateList newResult;
 
 		if (OidIsValid(namespaceId))
 		{
-			/* Consider only procs in specified namespace */
+			/* Consider only procs in specified schema */
 			if (procform->pronamespace != namespaceId)
 				continue;
 		}
 		else
 		{
 			/*
-			 * Consider only procs that are in the search path and are not in
-			 * the temp namespace.
+			 * The qualified name did not contain a schema name, so we will try to match with a schema
+			 * in the search path.
+			 * Consider only procs that are in the search path and are not in the temp namespace.
 			 */
 			ListCell   *nsp;
-
 			foreach(nsp, activeSearchPath)
 			{
 				if (procform->pronamespace == lfirst_oid(nsp) &&
 					procform->pronamespace != myTempNamespace)
+				{
+					schemaOid = lfirst_oid(nsp);
+					schemaname = get_namespace_name(schemaOid);
+					/* schema not originally specified, it was picked up from search path
+					   so may have to discard if this is not the correct proc*/
+					discardSchemanameIfNoMatch = true;
 					break;
+				}
 				pathpos++;
 			}
 			if (nsp == NULL)
 				continue;		/* proc is not in search path */
 		}
 
+		/* At this point a non-null schemaname has been set.
+		   If there is a module name to match against, then we will do that now */
+		if (modulename)
+		{
+			Oid nspoid = get_namespace_oid(schemaname, false);
+			moduleId = get_module_oid_from_name(nspoid, modulename, true);
+
+			/* Consider only if module oid is valid and the found proc is in specified module */
+			if (!OidIsValid(moduleId) || procform->promodule != moduleId)
+			{
+				if (discardSchemanameIfNoMatch)
+				{
+					/* if the schema name was picked up from the search path, discard it */
+					schemaname = NULL;
+					discardSchemanameIfNoMatch = false;
+				}
+				continue;
+			}
+		}
+		else
+		{
+			/* Searching for a proc that is not in any module,
+			   but the proc we found is in a module */
+			if (OidIsValid(procform->promodule) && (procform->promodule != 0))
+			{
+				continue;
+			}
+		}
+
 		/*
 		 * If we are asked to match to OUT arguments, then use the
 		 * proallargtypes array (which includes those); otherwise use
@@ -1494,7 +1545,6 @@ FunctionIsVisible(Oid funcid)
 
 		clist = FuncnameGetCandidates(list_make1(makeString(proname)),
 									  nargs, NIL, false, false, false, false);
-
 		for (; clist; clist = clist->next)
 		{
 			if (memcmp(clist->args, procform->proargtypes.values,
@@ -1533,7 +1583,7 @@ OpernameGetOprid(List *names, Oid oprleft, Oid oprright)
 	ListCell   *l;
 
 	/* deconstruct the name list */
-	DeconstructQualifiedName(names, &schemaname, &opername);
+	DeconstructQualifiedNameNoModule(names, &schemaname, &opername);
 
 	if (schemaname)
 	{
@@ -1640,7 +1690,7 @@ OpernameGetCandidates(List *names, char oprkind, bool missing_schema_ok)
 	int			i;
 
 	/* deconstruct the name list */
-	DeconstructQualifiedName(names, &schemaname, &opername);
+	DeconstructQualifiedNameNoModule(names, &schemaname, &opername);
 
 	if (schemaname)
 	{
@@ -2229,7 +2279,7 @@ get_statistics_object_oid(List *names, bool missing_ok)
 	ListCell   *l;
 
 	/* deconstruct the name list */
-	DeconstructQualifiedName(names, &schemaname, &stats_name);
+	DeconstructQualifiedNameNoModule(names, &schemaname, &stats_name);
 
 	if (schemaname)
 	{
@@ -2351,7 +2401,7 @@ get_ts_parser_oid(List *names, bool missing_ok)
 	ListCell   *l;
 
 	/* deconstruct the name list */
-	DeconstructQualifiedName(names, &schemaname, &parser_name);
+	DeconstructQualifiedNameNoModule(names, &schemaname, &parser_name);
 
 	if (schemaname)
 	{
@@ -2477,7 +2527,7 @@ get_ts_dict_oid(List *names, bool missing_ok)
 	ListCell   *l;
 
 	/* deconstruct the name list */
-	DeconstructQualifiedName(names, &schemaname, &dict_name);
+	DeconstructQualifiedNameNoModule(names, &schemaname, &dict_name);
 
 	if (schemaname)
 	{
@@ -2604,7 +2654,7 @@ get_ts_template_oid(List *names, bool missing_ok)
 	ListCell   *l;
 
 	/* deconstruct the name list */
-	DeconstructQualifiedName(names, &schemaname, &template_name);
+	DeconstructQualifiedNameNoModule(names, &schemaname, &template_name);
 
 	if (schemaname)
 	{
@@ -2730,7 +2780,7 @@ get_ts_config_oid(List *names, bool missing_ok)
 	ListCell   *l;
 
 	/* deconstruct the name list */
-	DeconstructQualifiedName(names, &schemaname, &config_name);
+	DeconstructQualifiedNameNoModule(names, &schemaname, &config_name);
 
 	if (schemaname)
 	{
@@ -2842,7 +2892,6 @@ TSConfigIsVisible(Oid cfgid)
 	return visible;
 }
 
-
 /*
  * DeconstructQualifiedName
  *		Given a possibly-qualified name expressed as a list of String nodes,
@@ -2851,17 +2900,18 @@ TSConfigIsVisible(Oid cfgid)
  * *nspname_p is set to NULL if there is no explicit schema name.
  */
 void
-DeconstructQualifiedName(List *names,
+DeconstructQualifiedNameNoModule(List *names,
 						 char **nspname_p,
 						 char **objname_p)
 {
 	char	   *catalogname;
-	char	   *schemaname = NULL;
-	char	   *objname = NULL;
+	char	   *schemaname;
+	char	   *objname;
 
 	switch (list_length(names))
 	{
 		case 1:
+			schemaname = NULL;
 			objname = strVal(linitial(names));
 			break;
 		case 2:
@@ -2872,7 +2922,6 @@ DeconstructQualifiedName(List *names,
 			catalogname = strVal(linitial(names));
 			schemaname = strVal(lsecond(names));
 			objname = strVal(lthird(names));
-
 			/*
 			 * We check the catalog name and then ignore it.
 			 */
@@ -2894,6 +2943,111 @@ DeconstructQualifiedName(List *names,
 	*objname_p = objname;
 }
 
+/*
+ * DeconstructQualifiedNameWithModule
+ *		Given a possibly-qualified name expressed as a list of String nodes,
+ *		extract the schema name, module name and object name.
+ *
+ * *nspname_p is set to NULL if there is no explicit schema name.
+ * *modname_p is set to NULL if there is no explicit module name.
+ */
+void
+DeconstructQualifiedNameWithModule(List *names,
+						 char **nspname_p,
+						 char **modname_p,
+						 char **objname_p)
+{
+	char	   *catalogname;
+	char	   *nspname = NULL;
+	char	   *modulename = NULL;
+	char	   *objname = NULL;
+
+	switch (list_length(names))
+	{
+		case 1:
+			objname = strVal(linitial(names));
+			break;
+		case 2:
+			if ((strcmp(strVal(linitial(names)), "pg_temp") == 0) || SearchSysCacheExists1(NAMESPACENAME, PointerGetDatum(strVal(linitial(names)))))
+			{
+				nspname = strVal(linitial(names));
+				/* If the object to create is itself a module, then objname is the modulename */
+				objname = strVal(lsecond(names));
+			}
+			else
+			{
+				modulename = strVal(linitial(names));
+				/* If the object to create is itself a module, then objname is the modulename */
+				objname = strVal(lsecond(names));
+			}
+			break;
+		case 3:
+				/*
+				 * Since we don't allow cross-database references, check if the
+				 * first element is the current catalog and if is different assume
+				 * the first element is a schema
+				 */
+				if (strcmp(strVal(linitial(names)), get_database_name(MyDatabaseId)) != 0)
+				{
+					if ((strcmp(strVal(linitial(names)), "pg_temp") == 0) || SearchSysCacheExists1(NAMESPACENAME, PointerGetDatum(strVal(linitial(names)))))
+					{
+						nspname = strVal(linitial(names));
+						modulename = strVal(lsecond(names));
+					}
+					else
+					{
+						/*
+						 * The first element is neither the current catalog nor a schema
+						 */
+						ereport(ERROR,
+								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+								 errmsg("cross-database references are not implemented: %s",
+										NameListToString(names))));
+					}
+				}
+				else
+				{
+					catalogname = strVal(linitial(names));
+					if ((strcmp(strVal(lsecond(names)), "pg_temp") == 0) || SearchSysCacheExists1(NAMESPACENAME, PointerGetDatum(strVal(lsecond(names)))))
+					{
+						nspname = strVal(lsecond(names));
+					}
+					else
+					{
+						modulename = strVal(lsecond(names));
+					}
+				}
+
+				objname = strVal(lthird(names));
+			break;
+		case 4:
+				catalogname = strVal(linitial(names));
+				nspname = strVal(lsecond(names));
+				modulename = strVal(lthird(names));
+				objname = strVal(lfourth(names));
+
+				/*
+				 * We check the catalog name and then ignore it.
+				 */
+				if (strcmp(catalogname, get_database_name(MyDatabaseId)) != 0)
+					ereport(ERROR,
+							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+							 errmsg("cross-database references are not implemented: %s",
+									NameListToString(names))));
+			break;
+		default:
+			ereport(ERROR,
+					(errcode(ERRCODE_SYNTAX_ERROR),
+					 errmsg("improper qualified name (too many dotted names): %s",
+							NameListToString(names))));
+			break;
+	}
+
+	/* nspname_p and/or modname_p can be set to NULL here if no nspname and/or modulename was parsed. */
+	*nspname_p = nspname;
+	*modname_p = modulename;
+	*objname_p = objname;
+}
 /*
  * LookupNamespaceNoError
  *		Look up a schema name.
@@ -2945,7 +3099,6 @@ LookupExplicitNamespace(const char *nspname, bool missing_ok)
 	{
 		if (OidIsValid(myTempNamespace))
 			return myTempNamespace;
-
 		/*
 		 * Since this is used only for looking up existing objects, there is
 		 * no point in trying to initialize the temp namespace here; and doing
@@ -2954,6 +3107,7 @@ LookupExplicitNamespace(const char *nspname, bool missing_ok)
 	}
 
 	namespaceId = get_namespace_oid(nspname, missing_ok);
+
 	if (missing_ok && !OidIsValid(namespaceId))
 		return InvalidOid;
 
@@ -2961,6 +3115,7 @@ LookupExplicitNamespace(const char *nspname, bool missing_ok)
 	if (aclresult != ACLCHECK_OK)
 		aclcheck_error(aclresult, OBJECT_SCHEMA,
 					   nspname);
+
 	/* Schema search hook for this lookup */
 	InvokeNamespaceSearchHook(namespaceId, true);
 
@@ -3024,42 +3179,70 @@ CheckSetNamespace(Oid oldNspOid, Oid nspOid)
 				 errmsg("cannot move objects into or out of TOAST schema")));
 }
 
-/*
- * QualifiedNameGetCreationNamespace
- *		Given a possibly-qualified name for an object (in List-of-Strings
- *		format), determine what namespace the object should be created in.
- *		Also extract and return the object name (last component of list).
- *
- * Note: this does not apply any permissions check.  Callers must check
- * for CREATE rights on the selected namespace when appropriate.
- *
- * Note: calling this may result in a CommandCounterIncrement operation,
- * if we have to create or clean out the temp namespace.
- */
+
 Oid
-QualifiedNameGetCreationNamespace(List *names, char **objname_p)
+get_module_oid_from_name(Oid nspoid, const char *modname, bool missing_ok)
 {
-	char	   *schemaname;
+	Oid			oid;
+
+	oid = GetSysCacheOid2(MODULENAME, Anum_pg_module_oid,
+						  CStringGetDatum(modname),  ObjectIdGetDatum(nspoid));
+
+	if (!OidIsValid(oid) && !missing_ok)
+		ereport(ERROR,
+				(errcode(ERRCODE_UNDEFINED_MODULE),
+				 errmsg("module \"%s\" in namespace \"%d\" does not exist", modname, nspoid)));
+	return oid;
+}
+
+Oid
+qualifiedNameGetCreationNamespaceHelper(List *names, Oid *moduleId, char **objname_p, bool check_module)
+{
+	char	   *nspname = NULL;
 	Oid			namespaceId;
+	char       *modulename = NULL;
 
 	/* deconstruct the name list */
-	DeconstructQualifiedName(names, &schemaname, objname_p);
+	if (check_module)
+		DeconstructQualifiedNameWithModule(names, &nspname, &modulename, objname_p);
+	else
+	{
+		DeconstructQualifiedNameNoModule(names, &nspname, objname_p);
+	}
 
-	if (schemaname)
+	if (nspname && modulename)
 	{
 		/* check for pg_temp alias */
-		if (strcmp(schemaname, "pg_temp") == 0)
+		if (strcmp(nspname, "pg_temp") == 0)
+		{
+			/* Initialize temp namespace */
+			AccessTempTableNamespace(false);
+			namespaceId = myTempNamespace;
+		}
+		else
+		{
+			namespaceId = get_namespace_oid(nspname, false);
+		}
+		*moduleId = get_module_oid_from_name(namespaceId, modulename, true);
+	}
+	else if (nspname)
+	{
+		*moduleId = InvalidOid;
+		/* check for pg_temp alias */
+		if (strcmp(nspname, "pg_temp") == 0)
 		{
 			/* Initialize temp namespace */
 			AccessTempTableNamespace(false);
 			return myTempNamespace;
 		}
 		/* use exact schema given */
-		namespaceId = get_namespace_oid(schemaname, false);
+		namespaceId = get_namespace_oid(nspname, false);
+
 		/* we do not check for USAGE rights here! */
 	}
 	else
 	{
+		*moduleId = InvalidOid;
 		/* use the default creation namespace */
 		recomputeNamespacePath();
 		if (activeTempCreationPending)
@@ -3072,12 +3255,50 @@ QualifiedNameGetCreationNamespace(List *names, char **objname_p)
 		if (!OidIsValid(namespaceId))
 			ereport(ERROR,
 					(errcode(ERRCODE_UNDEFINED_SCHEMA),
-					 errmsg("no schema has been selected to create in")));
+					 errmsg("no schema has been selected to create the module in")));
 	}
 
 	return namespaceId;
 }
 
+/*
+ * QualifiedNameGetCreationNamespace
+ *		Given a possibly-qualified name for an object (in List-of-Strings
+ *		format), determine what namespace the object should be created in.
+ *		Also extract and return the object name (last component of list).
+ *
+ * Note: this does not apply any permissions check.  Callers must check
+ * for CREATE rights on the selected namespace when appropriate.
+ *
+ * Note: calling this may result in a CommandCounterIncrement operation,
+ * if we have to create or clean out the temp namespace.
+ */
+Oid
+QualifiedNameGetCreationNamespace(List *names, char **objname_p)
+{
+	Oid moduleIdPlaceholder;
+	return qualifiedNameGetCreationNamespaceHelper(names, &moduleIdPlaceholder, objname_p, false);
+}
+
+/*
+ * QualifiedNameGetCreationNamespaceWithModule
+ *		Given a possibly-qualified name for an object (in List-of-Strings
+ *		format), that is allowed in a module, determine what namespace the
+ *      object should be created in.
+ *		Also extract and return the module oid and object name (last component of list).
+ *
+ * Note: this does not apply any permissions check.  Callers must check
+ * for CREATE rights on the selected namespace when appropriate.
+ *
+ * Note: calling this may result in a CommandCounterIncrement operation,
+ * if we have to create or clean out the temp namespace.
+ */
+Oid
+QualifiedNameWithModuleGetCreationNamespace(List *names, Oid *moduleId, char **objname_p)
+{
+	return qualifiedNameGetCreationNamespaceHelper(names, moduleId, objname_p, true);
+}
+
 /*
  * get_namespace_oid - given a namespace name, look up the OID
  *
@@ -3099,6 +3320,82 @@ get_namespace_oid(const char *nspname, bool missing_ok)
 	return oid;
 }
 
+/*
+ * get_module_oid - given a (possibly fully qualified) module name, look up the OID
+ *
+ * If missing_ok is false, throw an error if namespace or module name not found.  If
+ * true, just return InvalidOid.
+ */
+Oid
+get_module_oid(List *names, bool missing_ok)
+{
+	char	   *schemaname = NULL;
+	char	   *modulename = NULL;
+	char       *objname = NULL;
+	Oid			moduleId;
+	ListCell   *l;
+
+	/* Deconstruct the name list. Treat the module as an object */
+	DeconstructQualifiedNameWithModule(names, &schemaname, &modulename, &objname);
+
+	if (objname)
+		/* Deconstructing the name returned the object name which is the name of the module object */
+		modulename = objname;
+	else
+		/* Deconstruct did not find an object name. This should never happen.*/
+		ereport(ERROR, (errcode(ERRCODE_UNDEFINED_OBJECT), errmsg("Trying to get module oid for a corrupt path name %s",  NameListToString(names))));
+
+	if (schemaname)
+	{
+		Oid nspoid = get_namespace_oid(schemaname, false);
+		moduleId = get_module_oid_from_name(nspoid, modulename, true);
+	}
+	else
+	{
+		/* Schema name was not specified in the module name
+		 * so search for it in search path
+		 */
+		recomputeNamespacePath();
+		foreach(l, activeSearchPath)
+		{
+			Oid namespaceId;
+			namespaceId = lfirst_oid(l);
+			schemaname = get_namespace_name(namespaceId);
+			schemaname = NULL;
+		}
+
+		moduleId = InvalidOid;
+		foreach(l, activeSearchPath)
+		{
+			Oid namespaceId;
+			namespaceId = lfirst_oid(l);
+			if (namespaceId == PG_CATALOG_NAMESPACE)
+				continue;		/* do not look in pg_catalog */
+			if (namespaceId == myTempNamespace)
+				continue;		/* do not look in temp namespace */
+
+			schemaname = get_namespace_name(namespaceId);
+			if (!schemaname)
+				continue;		/* no such namespace? */
+
+			moduleId = get_module_oid_from_name(namespaceId, modulename, true);
+
+			if (OidIsValid(moduleId))
+			{
+				break;          /* Found a module with that name */
+			}
+		}
+	}
+
+	if (!OidIsValid(moduleId) && !missing_ok)
+		ereport(ERROR,
+				(errcode(ERRCODE_UNDEFINED_OBJECT),
+				 errmsg("module \"%s\" does not exist",
+						NameListToString(names))));
+
+	return moduleId;
+}
+
 /*
  * makeRangeVarFromNameList
  *		Utility routine to convert a qualified-name list into RangeVar form.
@@ -3653,7 +3950,7 @@ get_collation_oid(List *name, bool missing_ok)
 	ListCell   *l;
 
 	/* deconstruct the name list */
-	DeconstructQualifiedName(name, &schemaname, &collation_name);
+	DeconstructQualifiedNameNoModule(name, &schemaname, &collation_name);
 
 	if (schemaname)
 	{
@@ -3706,7 +4003,7 @@ get_conversion_oid(List *name, bool missing_ok)
 	ListCell   *l;
 
 	/* deconstruct the name list */
-	DeconstructQualifiedName(name, &schemaname, &conversion_name);
+	DeconstructQualifiedNameNoModule(name, &schemaname, &conversion_name);
 
 	if (schemaname)
 	{
@@ -4044,8 +4341,7 @@ InitTempTableNamespace(void)
 		 * temp tables.  This works because the places that access the temp
 		 * namespace for my own backend skip permissions checks on it.
 		 */
-		namespaceId = NamespaceCreate(namespaceName, BOOTSTRAP_SUPERUSERID,
-									  true);
+		namespaceId = NamespaceCreate(namespaceName, BOOTSTRAP_SUPERUSERID, true);
 		/* Advance command counter to make namespace visible */
 		CommandCounterIncrement();
 	}
@@ -4069,8 +4365,7 @@ InitTempTableNamespace(void)
 	toastspaceId = get_namespace_oid(namespaceName, true);
 	if (!OidIsValid(toastspaceId))
 	{
-		toastspaceId = NamespaceCreate(namespaceName, BOOTSTRAP_SUPERUSERID,
-									   true);
+		toastspaceId = NamespaceCreate(namespaceName, BOOTSTRAP_SUPERUSERID, true);
 		/* Advance command counter to make namespace visible */
 		CommandCounterIncrement();
 	}
diff --git a/src/backend/catalog/objectaddress.c b/src/backend/catalog/objectaddress.c
index f30c742d48..d1f94e1fc6 100644
--- a/src/backend/catalog/objectaddress.c
+++ b/src/backend/catalog/objectaddress.c
@@ -41,6 +41,7 @@
 #include "catalog/pg_language.h"
 #include "catalog/pg_largeobject.h"
 #include "catalog/pg_largeobject_metadata.h"
+#include "catalog/pg_module.h"
 #include "catalog/pg_namespace.h"
 #include "catalog/pg_opclass.h"
 #include "catalog/pg_operator.h"
@@ -413,6 +414,20 @@ static const ObjectPropertyType ObjectProperty[] =
 		OBJECT_SCHEMA,
 		true
 	},
+	{
+		"module",
+		ModuleRelationId,
+		ModuleOidIndexId,
+		MODULEOID,
+		MODULENAME,
+		Anum_pg_module_oid,
+		Anum_pg_module_modname,
+		Anum_pg_module_nspoid,
+		Anum_pg_module_modowner,
+		Anum_pg_module_modacl,
+		OBJECT_MODULE,
+		true
+	},
 	{
 		"relation",
 		RelationRelationId,
@@ -766,6 +781,10 @@ static const struct object_type_map
 	{
 		"schema", OBJECT_SCHEMA
 	},
+	/* OCLASS_MODULE */
+	{
+		"module", OBJECT_MODULE
+	},
 	/* OCLASS_TSPARSER */
 	{
 		"text search parser", OBJECT_TSPARSER
@@ -943,7 +962,6 @@ get_object_address(ObjectType objtype, Node *object,
 
 	/* Some kind of lock must be taken. */
 	Assert(lockmode != NoLock);
-
 	for (;;)
 	{
 		/*
@@ -1139,6 +1157,11 @@ get_object_address(ObjectType objtype, Node *object,
 															 missing_ok);
 				address.objectSubId = 0;
 				break;
+			case OBJECT_MODULE:
+				address.classId = ModuleRelationId;
+				address.objectId = get_module_oid(castNode(List, object), missing_ok);
+				address.objectSubId = 0;
+				break;
 			default:
 				elog(ERROR, "unrecognized objtype: %d", (int) objtype);
 				/* placate compiler, in case it thinks elog might return */
@@ -2322,6 +2345,7 @@ pg_get_object_address(PG_FUNCTION_ARGS)
 		case OBJECT_TABCONSTRAINT:
 		case OBJECT_OPCLASS:
 		case OBJECT_OPFAMILY:
+		case OBJECT_MODULE:
 			objnode = (Node *) name;
 			break;
 		case OBJECT_ACCESS_METHOD:
@@ -2491,6 +2515,11 @@ check_object_ownership(Oid roleid, ObjectType objtype, ObjectAddress address,
 				aclcheck_error(ACLCHECK_NOT_OWNER, objtype,
 							   strVal(object));
 			break;
+		case OBJECT_MODULE:
+			if (!pg_module_ownercheck(address.objectId, roleid))
+				aclcheck_error(ACLCHECK_NOT_OWNER, objtype,
+							   strVal(object));
+			break;
 		case OBJECT_COLLATION:
 			if (!pg_collation_ownercheck(address.objectId, roleid))
 				aclcheck_error(ACLCHECK_NOT_OWNER, objtype,
@@ -2968,6 +2997,34 @@ getObjectDescription(const ObjectAddress *object, bool missing_ok)
 
 	switch (getObjectClass(object))
 	{
+		case OCLASS_MODULE:
+			{
+				Relation	modRel;
+				HeapTuple	tup;
+				Form_pg_module modForm;
+
+				modRel = table_open(ModuleRelationId, AccessShareLock);
+
+				tup = get_catalog_object_by_oid(modRel, Anum_pg_module_oid,
+												object->objectId);
+
+				if (!HeapTupleIsValid(tup))
+				{
+					if (!missing_ok)
+						elog(ERROR, "could not find tuple for module %u",
+							 object->objectId);
+
+					table_close(modRel, AccessShareLock);
+					break;
+				}
+
+				modForm = (Form_pg_module) GETSTRUCT(tup);
+
+				appendStringInfo(&buffer, _("module %s"), (modForm->modname).data);
+
+				table_close(modRel, AccessShareLock);
+				break;
+			}
 		case OCLASS_CLASS:
 			if (object->objectSubId == 0)
 				getRelationDescription(&buffer, object->objectId, missing_ok);
@@ -4530,6 +4587,10 @@ getObjectTypeDescription(const ObjectAddress *object, bool missing_ok)
 			appendStringInfoString(&buffer, "schema");
 			break;
 
+		case OCLASS_MODULE:
+			appendStringInfoString(&buffer, "module");
+			break;
+
 		case OCLASS_STATISTIC_EXT:
 			appendStringInfoString(&buffer, "statistics object");
 			break;
@@ -4850,6 +4911,35 @@ getObjectIdentityParts(const ObjectAddress *object,
 				break;
 			}
 
+		case OCLASS_MODULE:
+			{
+				Relation	modRel;
+				HeapTuple	tup;
+				Form_pg_module modForm;
+
+				modRel = table_open(ModuleRelationId, AccessShareLock);
+
+				tup = get_catalog_object_by_oid(modRel, Anum_pg_module_oid,
+												object->objectId);
+
+				if (!HeapTupleIsValid(tup))
+				{
+					if (!missing_ok)
+						elog(ERROR, "could not find tuple for module %u",
+							 object->objectId);
+
+					table_close(modRel, AccessShareLock);
+					break;
+				}
+
+				modForm = (Form_pg_module) GETSTRUCT(tup);
+
+				appendStringInfo(&buffer, "module %s", (modForm->modname).data);
+
+				table_close(modRel, AccessShareLock);
+				break;
+			}
+
 		case OCLASS_TYPE:
 			{
 				bits16		flags = FORMAT_TYPE_INVALID_AS_NULL | FORMAT_TYPE_FORCE_QUALIFY;
diff --git a/src/backend/catalog/pg_aggregate.c b/src/backend/catalog/pg_aggregate.c
index 0d0daa69b3..b033286fb7 100644
--- a/src/backend/catalog/pg_aggregate.c
+++ b/src/backend/catalog/pg_aggregate.c
@@ -614,6 +614,7 @@ AggregateCreate(const char *aggName,
 
 	myself = ProcedureCreate(aggName,
 							 aggNamespace,
+							 InvalidOid, /* not in a module */
 							 replace,	/* maybe replacement */
 							 false, /* doesn't return a set */
 							 finaltype, /* returnType */
diff --git a/src/backend/catalog/pg_module.c b/src/backend/catalog/pg_module.c
new file mode 100644
index 0000000000..3312e334c7
--- /dev/null
+++ b/src/backend/catalog/pg_module.c
@@ -0,0 +1,118 @@
+/*-------------------------------------------------------------------------
+ *
+ * pg_module.c
+ *	  routines to support manipulation of the pg_module relation
+ *
+ * Portions Copyright (c) 1996-2021, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ *
+ * IDENTIFICATION
+ *	  src/backend/catalog/pg_module.c
+ *
+ *-------------------------------------------------------------------------
+ */
+#include "postgres.h"
+
+#include "access/htup_details.h"
+#include "access/table.h"
+#include "catalog/catalog.h"
+#include "catalog/dependency.h"
+#include "catalog/indexing.h"
+#include "catalog/namespace.h"
+#include "catalog/objectaccess.h"
+#include "catalog/pg_module.h"
+#include "utils/builtins.h"
+#include "utils/rel.h"
+#include "utils/syscache.h"
+
+
+/* ----------------
+ * ModuleCreate
+ *
+ * Create a module with the given name and owner OID.
+ *
+ * ---------------
+ */
+Oid
+ModuleCreate(const char *modName, const char *nspName, Oid ownerId)
+{
+	Relation	modDesc;
+	HeapTuple	tup;
+	Oid     	modOid;
+	Oid     	nspOid;
+	bool		nulls[Natts_pg_module];
+	Datum		values[Natts_pg_module];
+	NameData	nname;
+	TupleDesc	tupDesc;
+	ObjectAddress myself;
+	int     	i;
+	Acl        *modAcl;
+
+	/* sanity checks */
+	if (!modName)
+		elog(ERROR, "no module name supplied");
+
+	if (!nspName)
+		elog(ERROR, "no parent namespace name supplied");
+
+	nspOid = get_namespace_oid(nspName, false);
+
+	if (SearchSysCacheExists2(MODULENAME, PointerGetDatum(modName), ObjectIdGetDatum(nspOid)))
+		ereport(ERROR, (errcode(ERRCODE_DUPLICATE_MODULE),
+						errmsg("module \"%s\" already exists in schema \"%s\"", modName, nspName)));
+
+	modAcl = get_user_default_acl(OBJECT_MODULE, ownerId,
+								  InvalidOid);
+
+	modDesc = table_open(ModuleRelationId, RowExclusiveLock);
+	tupDesc = modDesc->rd_att;
+
+	/* initialize nulls and values */
+	for (i = 0; i < Natts_pg_module; i++)
+	{
+		nulls[i] = false;
+		values[i] = (Datum) NULL;
+	}
+
+	modOid = GetNewOidWithIndex(modDesc, ModuleOidIndexId,
+								Anum_pg_module_oid);
+	values[Anum_pg_module_oid - 1] = ObjectIdGetDatum(modOid);
+
+	namestrcpy(&nname, modName);
+	//namestrcpy(&schemaname, nspName);
+
+	values[Anum_pg_module_modname - 1] = NameGetDatum(&nname);
+	values[Anum_pg_module_nspoid - 1] = ObjectIdGetDatum(nspOid);
+	values[Anum_pg_module_modowner - 1] = ObjectIdGetDatum(ownerId);
+	if (modAcl != NULL)
+		values[Anum_pg_module_modacl - 1] = PointerGetDatum(modAcl);
+	else
+		nulls[Anum_pg_module_modacl - 1] = true;
+
+	tup = heap_form_tuple(tupDesc, values, nulls);
+
+	CatalogTupleInsert(modDesc, tup);
+	Assert(OidIsValid(modOid));
+
+	table_close(modDesc, RowExclusiveLock);
+
+	/* Record dependencies */
+	myself.classId = ModuleRelationId;
+	myself.objectId = modOid;
+	myself.objectSubId = 0;
+
+	/* dependency on owner */
+	recordDependencyOnOwner(ModuleRelationId, modOid, ownerId);
+
+	/* dependencies on roles mentioned in default ACL */
+	recordDependencyOnNewAcl(ModuleRelationId, modOid, 0, ownerId, modAcl);
+
+	/* dependency on extension */
+	recordDependencyOnCurrentExtension(&myself, false);
+
+	/* Post creation hook for new schema */
+	InvokeObjectPostCreateHook(ModuleRelationId, modOid, 0);
+
+	return modOid;
+}
diff --git a/src/backend/catalog/pg_proc.c b/src/backend/catalog/pg_proc.c
index 12521c77c3..928d1f790a 100644
--- a/src/backend/catalog/pg_proc.c
+++ b/src/backend/catalog/pg_proc.c
@@ -22,6 +22,7 @@
 #include "catalog/indexing.h"
 #include "catalog/objectaccess.h"
 #include "catalog/pg_language.h"
+#include "catalog/pg_module.h"
 #include "catalog/pg_namespace.h"
 #include "catalog/pg_proc.h"
 #include "catalog/pg_transform.h"
@@ -70,6 +71,7 @@ static bool match_prosrc_to_literal(const char *prosrc, const char *literal,
 ObjectAddress
 ProcedureCreate(const char *procedureName,
 				Oid procNamespace,
+				Oid procModule,
 				bool replace,
 				bool returnsSet,
 				Oid returnType,
@@ -300,6 +302,7 @@ ProcedureCreate(const char *procedureName,
 	namestrcpy(&procname, procedureName);
 	values[Anum_pg_proc_proname - 1] = NameGetDatum(&procname);
 	values[Anum_pg_proc_pronamespace - 1] = ObjectIdGetDatum(procNamespace);
+	values[Anum_pg_proc_promodule - 1] = ObjectIdGetDatum(procModule);
 	values[Anum_pg_proc_proowner - 1] = ObjectIdGetDatum(proowner);
 	values[Anum_pg_proc_prolang - 1] = ObjectIdGetDatum(languageObjectId);
 	values[Anum_pg_proc_procost - 1] = Float4GetDatum(procost);
@@ -356,10 +359,11 @@ ProcedureCreate(const char *procedureName,
 	tupDesc = RelationGetDescr(rel);
 
 	/* Check for pre-existing definition */
-	oldtup = SearchSysCache3(PROCNAMEARGSNSP,
+	oldtup = SearchSysCache4(PROCNAMEARGSNSP,
 							 PointerGetDatum(procedureName),
 							 PointerGetDatum(parameterTypes),
-							 ObjectIdGetDatum(procNamespace));
+							 ObjectIdGetDatum(procNamespace),
+							 ObjectIdGetDatum(procModule));
 
 	if (HeapTupleIsValid(oldtup))
 	{
@@ -374,6 +378,7 @@ ProcedureCreate(const char *procedureName,
 					(errcode(ERRCODE_DUPLICATE_FUNCTION),
 					 errmsg("function \"%s\" already exists with same argument types",
 							procedureName)));
+
 		if (!pg_proc_ownercheck(oldproc->oid, proowner))
 			aclcheck_error(ACLCHECK_NOT_OWNER, OBJECT_FUNCTION,
 						   procedureName);
@@ -604,6 +609,10 @@ ProcedureCreate(const char *procedureName,
 	ObjectAddressSet(referenced, NamespaceRelationId, procNamespace);
 	add_exact_object_address(&referenced, addrs);
 
+	/* dependency on module */
+	ObjectAddressSet(referenced, ModuleRelationId, procModule);
+	add_exact_object_address(&referenced, addrs);
+
 	/* dependency on implementation language */
 	ObjectAddressSet(referenced, LanguageRelationId, languageObjectId);
 	add_exact_object_address(&referenced, addrs);
